86d482068aadacbc82e274687cc5a28fe95d4aeb
[csit.git] / resources / libraries / bash / function / device.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Licensed under the Apache License, Version 2.0 (the "License");
3 # you may not use this file except in compliance with the License.
4 # You may obtain a copy of the License at:
5 #
6 #     http://www.apache.org/licenses/LICENSE-2.0
7 #
8 # Unless required by applicable law or agreed to in writing, software
9 # distributed under the License is distributed on an "AS IS" BASIS,
10 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11 # See the License for the specific language governing permissions and
12 # limitations under the License.
13
14 set -exuo pipefail
15
16 # This library defines functions used by multiple entry scripts.
17 # Deliberately not depending on common.sh to allow standalone usage.
18 # Keep functions ordered alphabetically, please.
19
20 function activate_wrapper () {
21
22     # Acts as wrapper for activate docker topology.
23     #
24     # Variables read:
25     # - ${1} - Node multiplicity of desired testbed.
26     # - ${2} - Node flavor string, usually describing the processor.
27     # - ${3} - CSIT-SUT-DCR image name and version.
28
29     set -exuo pipefail
30
31     enter_mutex || die
32     get_available_interfaces "${1}" "${2}" || die
33     bind_dut_interfaces_to_vpp_driver || die
34     start_topology_containers "${3}" || die
35     bind_interfaces_to_containers || die
36     set_env_variables || die
37     print_env_variables || die
38     exit_mutex || die
39 }
40
41
42 function bind_dut_interfaces_to_vpp_driver () {
43
44     # Bind DUT network interfaces to the driver that vpp will use
45     #
46     # Variables read:
47     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
48     # Variables set:
49     # - NETDEV - Linux network interface.
50     # - DRIVER - Kernel driver to bind the interface to.
51     # - KRN_DRIVER - The original kernel driver of the network interface.
52
53     for NETDEV in "${DUT1_NETDEVS[@]}"; do
54         get_pci_addr || die
55         get_krn_driver || die
56         if [[ ${KRN_DRIVER} == "iavf" ]]; then
57             DRIVER="vfio-pci"
58             ADDR=${PCI_ADDR}
59             bind_interfaces_to_driver || die
60         fi
61     done
62 }
63
64
65 function bind_interfaces_to_containers () {
66
67     # Bind linux network interface to container and create symlink for PCI
68     # address in container.
69     #
70     # Variables read:
71     # - DCR_UUIDS - Docker Container UUIDs.
72     # - DCR_CPIDS - Docker Container PIDs (namespaces).
73     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
74     # - PCI_ADDR - PCI address of network device.
75     # - TG_NETDEVS - List of network devices allocated to TG container.
76     # Variables set:
77     # - NETDEV - Linux network interface.
78     # - KRN_DRIVER - Kernel driver of network device.
79
80     set -exuo pipefail
81
82     for PCI_ADDR in "${TG_PCIDEVS[@]}"; do
83         get_netdev_name || die
84         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
85             die "Reading symlink for PCI address failed!"
86         }
87         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
88
89         docker exec "${DCR_UUIDS[tg]}" ${cmd} || {
90             die "Linking PCI address in container failed!"
91         }
92
93         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[tg]} || {
94             die "Moving interface to ${DCR_CPIDS[tg]} namespace failed!"
95         }
96     done
97     for PCI_ADDR in "${DUT1_PCIDEVS[@]}"; do
98         link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
99             die "Reading symlink for PCI address failed!"
100         }
101         cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
102
103         docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
104             die "Linking PCI address in container failed!"
105         }
106
107         get_krn_driver
108         if [[ ${KRN_DRIVER} != "vfio-pci" ]]; then
109             get_netdev_name || die
110             sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
111                 die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
112             }
113         fi
114     done
115 }
116
117
118 function bind_interfaces_to_driver () {
119
120     # Bind network interface specified by parameter to driver specified by
121     # parameter.
122     #
123     # Variables read:
124     # - ADDR - PCI address of network interface.
125     # - DRIVER - Kernel driver.
126
127     set -exuo pipefail
128
129     pci_path="/sys/bus/pci/devices/${ADDR}"
130     drv_path="/sys/bus/pci/drivers/${DRIVER}"
131     if [ -d "${pci_path}/driver" ]; then
132         echo ${ADDR} | sudo tee ${pci_path}/driver/unbind > /dev/null || {
133             die "Failed to unbind interface ${ADDR}!"
134         }
135     fi
136
137     echo ${DRIVER} | sudo tee /sys/bus/pci/devices/${ADDR}/driver_override \
138         > /dev/null || {
139         die "Failed to override driver to ${DRIVER} for ${ADDR}!"
140     }
141
142     echo ${ADDR} | sudo tee ${drv_path}/bind > /dev/null || {
143         die "Failed to bind interface ${ADDR}!"
144     }
145
146     echo | sudo tee /sys/bus/pci/devices/${ADDR}/driver_override > /dev/null \
147         || die "Failed to reset driver override for ${ADDR}!"
148 }
149
150
151 function clean_environment () {
152
153     # Cleanup environment by removing topology containers and shared volumes
154     # and binding interfaces back to original driver.
155     #
156     # Variables read:
157     # - DCR_UUIDS - Docker Container UUIDs.
158     # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
159     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
160     # Variables set:
161     # - ADDR - PCI address of network interface.
162     # - DRIVER - Kernel driver.
163
164     set -exuo pipefail
165
166     # Kill docker containers.
167     docker rm --force "${DCR_UUIDS[@]}" || die "Cleanup containers failed!"
168
169     # Check if there are some leftover containers and remove all. Command will
170     # not fail in case there are no containers to remove.
171     docker rm --force $(docker ps -q --filter name=${DCR_UUIDS[dut1]}) || {
172         warn "Failed to remove hanged containers or nothing to remove!"
173     }
174
175     # Rebind interfaces back to kernel drivers.
176     for ADDR in ${TG_PCIDEVS[@]}; do
177         DRIVER="${TG_DRIVERS[0]}"
178         bind_interfaces_to_driver || die
179     done
180     for ADDR in ${DUT1_PCIDEVS[@]}; do
181         DRIVER="${DUT1_DRIVERS[0]}"
182         bind_interfaces_to_driver || die
183     done
184 }
185
186
187 function clean_environment_on_exit () {
188
189     # Cleanup environment by removing topology containers and binding
190     # interfaces back to original driver only if exit code is not 0.
191     # This function acts as workaround as 'set -eu' does not trigger ERR trap.
192
193     set -exuo pipefail
194
195     if [ $? -ne 0 ]; then
196         clean_environment || die
197     fi
198 }
199
200
201 function deactivate_wrapper () {
202
203     # Acts as wrapper for deactivate docker topology.
204     #
205     # Variables read:
206     # - ${@} - CSIT environment variables.
207
208     set -exuo pipefail
209
210     enter_mutex || die
211     read_env_variables "${@}" || die
212     clean_environment || die
213     exit_mutex || die
214 }
215
216
217 function die () {
218
219     # Print the message to standard error end exit with error code specified
220     # by the second argument.
221     #
222     # Duplicate of common.sh function, as this file is also used standalone.
223     #
224     # Hardcoded values:
225     # - The default error message.
226     # Arguments:
227     # - ${1} - The whole error message, be sure to quote. Optional
228     # - ${2} - the code to exit with, default: 1.
229
230     set -x
231     set +eu
232     warn "${1:-Unspecified run-time error occurred!}"
233     exit "${2:-1}"
234 }
235
236
237 function enter_mutex () {
238
239     # Enter mutual exclusion for protecting execution from starvation and
240     # deadlock.
241
242     set -exuo pipefail
243
244     mutex_timeout=3600
245     mutex_file="/tmp/mutex_file"
246
247     # Create mutex.
248     exec {lock_fd}>${mutex_file} || {
249         die "Mutex enter failed!"
250     }
251     flock --timeout "${mutex_timeout}" "${lock_fd}" || {
252         die "Calling flock() failed!"
253     }
254     # ----------------------
255     # Enter mutex succeeded.
256     warn "Mutex enter succeeded for PID $$."
257 }
258
259
260 function exit_mutex () {
261
262     # Exit mutual exclusion.
263
264     set -exuo pipefail
265
266     # ---------------------
267     # Remove mutex so we are not blocking others anymore.
268     flock -u "${lock_fd}" || {
269         die "Mutex destroy failed!"
270     }
271     warn "Mutex leave succeeded for PID $$."
272 }
273
274
275 function get_available_interfaces () {
276
277     # Find and get available Virtual functions.
278     #
279     # Arguments:
280     # - ${1} - Nodeness, as set by common.sh get_test_code.
281     # - ${2} - Flavor, as set by common.sh get_test_code.
282     # Variables set:
283     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
284     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
285     # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
286     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
287     # - DUT1_VLANS - List of interface vlans to TG container.
288     # - DUT1_MODEL - List of interface models to TG container.
289     # - TG_NETDEVS - List of network devices allocated to TG container.
290     # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
291     # - TG_NETMACS - List of MAC addresses allocated to TG container.
292     # - TG_DRIVERS - List of interface drivers to TG container.
293     # - TG_VLANS - List of interface vlans to TG container.
294     # - TG_MODEL - List of interface models to TG container.
295
296     set -exuo pipefail
297
298     # Following code is specifying VFs ID based on nodeness and flavor.
299     # As there is great variability in hardware configuration outside LF,
300     # from bootstrap architecture point of view these are considered as flavors.
301     # Anyone can override flavor for its own machine and add condition here.
302     # See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
303     case_text="${1}_${2}"
304     case "${case_text}" in
305         "1n_skx")
306             # Add Intel Corporation XL710/X710 Virtual Function to the
307             # whitelist.
308             # Add Intel Corporation E810 Virtual Function to the
309             # whitelist.
310             pci_id="0x154c\|0x1889"
311             tg_netdev=(ens1 enp134)
312             dut1_netdev=(ens5 enp175)
313             ports_per_nic=2
314             ;;
315        "1n_tx2")
316             # Add Intel Corporation XL710/X710 Virtual Function to the
317             # whitelist.
318             pci_id="0x154c"
319             tg_netdev=(enp5)
320             dut1_netdev=(enp145)
321             ports_per_nic=2
322             ;;
323        "1n_vbox")
324             # Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
325             # whitelist.
326             pci_id="0x100f"
327             tg_netdev=(enp0s8 enp0s9)
328             dut1_netdev=(enp0s16 enp0s17)
329             ports_per_nic=1
330             ;;
331         *)
332             die "Unknown specification: ${case_text}!"
333     esac
334
335     # TG side of connections.
336     TG_NETDEVS=()
337     TG_PCIDEVS=()
338     TG_NETMACS=()
339     TG_DRIVERS=()
340     TG_VLANS=()
341     TG_MODEL=()
342     # DUT1 side of connections.
343     DUT1_NETDEVS=()
344     DUT1_PCIDEVS=()
345     DUT1_NETMACS=()
346     DUT1_DRIVERS=()
347     DUT1_VLANS=()
348     DUT1_MODEL=()
349
350     # Find the first ${device_count} number of available TG Linux network
351     # VF device names. Only allowed VF PCI IDs are filtered.
352     for netdev in ${tg_netdev[@]}
353     do
354         ports=0
355         for netdev_path in $(grep -l "${pci_id}" \
356                              /sys/class/net/${netdev}*/device/device \
357                              2> /dev/null)
358         do
359             if [[ ${ports} -lt ${ports_per_nic} ]]; then
360                 tg_netdev_name=$(dirname ${netdev_path})
361                 tg_netdev_name=$(dirname ${tg_netdev_name})
362                 TG_NETDEVS+=($(basename ${tg_netdev_name}))
363                 ((ports++))
364             else
365                 break
366             fi
367         done
368         ports_per_device=$((${ports_per_nic}*${#tg_netdev[@]}))
369         if [[ ${#TG_NETDEVS[@]} -eq ${ports_per_device} ]]; then
370             break
371         fi
372     done
373
374     i=0
375     for netdev in "${TG_NETDEVS[@]}"; do
376         # Find the index of selected tg netdev among tg_netdevs
377         # e.g. enp8s5f7 is a vf of netdev enp8s5 with index 11
378         # and the corresponding dut1 netdev is enp133s13.
379         while [[ "${netdev}" != "${tg_netdev[$i]}"* ]]; do
380             ((i++))
381         done
382         # Rename tg netdev to dut1 netdev
383         # e.g. enp8s5f7 -> enp133s13f7
384         DUT1_NETDEVS+=(${netdev/${tg_netdev[$i]}/${dut1_netdev[$i]}})
385         # Don't need to reset i, all netdevs are sorted.
386     done
387
388     for NETDEV in "${TG_NETDEVS[@]}"; do
389         get_pci_addr
390         get_mac_addr
391         get_krn_driver
392         get_vlan_filter
393         get_csit_model
394         TG_PCIDEVS+=(${PCI_ADDR})
395         TG_NETMACS+=(${MAC_ADDR})
396         TG_DRIVERS+=(${KRN_DRIVER})
397         TG_VLANS+=(${VLAN_ID})
398         TG_MODELS+=(${MODEL})
399     done
400     for NETDEV in "${DUT1_NETDEVS[@]}"; do
401         get_pci_addr
402         get_mac_addr
403         get_krn_driver
404         get_vlan_filter
405         get_csit_model
406         DUT1_PCIDEVS+=(${PCI_ADDR})
407         DUT1_NETMACS+=(${MAC_ADDR})
408         DUT1_DRIVERS+=(${KRN_DRIVER})
409         DUT1_VLANS+=(${VLAN_ID})
410         DUT1_MODELS+=(${MODEL})
411     done
412
413     # We need at least two interfaces for TG/DUT1 for building topology.
414     if [ "${#TG_NETDEVS[@]}" -lt 2 ] || [ "${#DUT1_NETDEVS[@]}" -lt 2 ]; then
415         die "Not enough linux network interfaces found!"
416     fi
417 }
418
419
420 function get_krn_driver () {
421
422     # Get kernel driver from linux network device name.
423     #
424     # Variables read:
425     # - PCI_ADDR - PCI address of network device.
426     # Variables set:
427     # - KRN_DRIVER - Kernel driver of network device.
428
429     set -exuo pipefail
430
431     pci_path="/sys/bus/pci/devices/${PCI_ADDR}"
432     KRN_DRIVER="$(basename $(readlink -f ${pci_path}/driver))" || {
433         die "Failed to get kernel driver of PCI interface!"
434     }
435 }
436
437
438 function get_mac_addr () {
439
440     # Get MAC address from linux network device name.
441     #
442     # Variables read:
443     # - NETDEV - Linux network device name.
444     # Variables set:
445     # - MAC_ADDR - MAC address of network device.
446
447     set -exuo pipefail
448
449     if [ -d /sys/class/net/${NETDEV}/device ]; then
450         MAC_ADDR="$(</sys/class/net/${NETDEV}/address)" || {
451             die "Failed to get MAC address of linux network interface!"
452         }
453     fi
454 }
455
456
457 function get_netdev_name () {
458
459     # Get Linux network device name.
460     #
461     # Variables read:
462     # - PCI_ADDR - PCI address of the device.
463     # Variables set:
464     # - NETDEV - Linux network device name.
465
466     set -exuo pipefail
467
468     if [ -d /sys/bus/pci/devices/${PCI_ADDR}/net ]; then
469         NETDEV="$(basename /sys/bus/pci/devices/${PCI_ADDR}/net/*)" || {
470             die "Failed to get Linux interface name of ${PCI_ADDR}"
471         }
472     fi
473 }
474
475
476 function get_csit_model () {
477
478     # Get CSIT model name from linux network device name.
479     #
480     # Variables read:
481     # - NETDEV - Linux network device name.
482     # Variables set:
483     # - MODEL - CSIT model name of network device.
484
485     set -exuo pipefail
486
487     if [ -d /sys/class/net/${NETDEV}/device ]; then
488         ID="$(</sys/class/net/${NETDEV}/device/device)" || {
489             die "Failed to get device id of linux network interface!"
490         }
491         case "${ID}" in
492             "0x1592"|"0x1889")
493                 MODEL="Intel-E810CQ"
494                 ;;
495             "0x1572"|"0x154c")
496                 MODEL="Intel-X710"
497                 ;;
498             "*")
499                 MODEL="virtual"
500         esac
501     fi
502 }
503
504
505 function get_pci_addr () {
506
507     # Get PCI address in <domain>:<bus:<device>.<func> format from linux network
508     # device name.
509     #
510     # Variables read:
511     # - NETDEV - Linux network device name.
512     # Variables set:
513     # - PCI_ADDR - PCI address of network device.
514
515     set -exuo pipefail
516
517     if [ -d /sys/class/net/${NETDEV}/device ]; then
518         PCI_ADDR=$(basename $(readlink /sys/class/net/${NETDEV}/device)) || {
519             die "Failed to get PCI address of linux network interface!"
520         }
521         if [ ! -d /sys/bus/pci/devices/${PCI_ADDR} ]; then
522             die "PCI device ${PCI_ADDR} doesn't exist!"
523         fi
524     else
525         die "Can't get device info of interface ${NETDEV}!"
526     fi
527 }
528
529
530 function get_vfio_group () {
531
532     # Get the VFIO group of a pci device.
533     #
534     # Variables read:
535     # - PCI_ADDR - PCI address of a device.
536     # Variables set:
537     # - VFIO_GROUP - The VFIO group of the PCI device.
538
539     if [[ -d /sys/bus/pci/devices/${PCI_ADDR}/iommu_group ]]; then
540         VFIO_GROUP="$(basename\
541             $(readlink /sys/bus/pci/devices/${PCI_ADDR}/iommu_group)\
542         )" || {
543             die "PCI device ${PCI_ADDR} does not have an iommu group!"
544         }
545     fi
546 }
547
548 function get_vlan_filter () {
549
550     # Get VLAN stripping filter from PF searched by mac adress.
551     #
552     # Variables read:
553     # - MAC_ADDR - MAC address of VF.
554     # Variables set:
555     # - VLAN_ID - VLAN ids.
556
557     set -exuo pipefail
558
559     # Sed regular expression pattern.
560     exp="s/^.*vlan ([[:digit:]]+).*$/\1/"
561     VLAN_ID=$(ip link | grep vlan | grep ${MAC_ADDR} | sed -re "${exp}") || true
562     VLAN_ID="${VLAN_ID:-0}"
563 }
564
565
566 function installed () {
567
568     # Check if the given utility is installed. Fail if not installed.
569     #
570     # Duplicate of common.sh function, as this file is also used standalone.
571     #
572     # Arguments:
573     # - ${1} - Utility to check.
574     # Returns:
575     # - 0 - If command is installed.
576     # - 1 - If command is not installed.
577
578     set -exuo pipefail
579
580     command -v "${1}"
581 }
582
583
584 function parse_env_variables () {
585
586     # Parse environment variables.
587     #
588     # Variables read, set or exported: Multiple,
589     # see the code for the current list.
590
591     set -exuo pipefail
592
593     IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
594     IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
595     IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
596     IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
597     IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
598     IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
599     IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
600     IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
601     IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
602     IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
603
604     for port in $(seq "${#TG_NETMACS[*]}"); do
605         CSIT_TG_INTERFACES+=$(cat << EOF
606         port$((port-1)):
607             mac_address: "${TG_NETMACS[$((port-1))]}"
608             pci_address: "${TG_PCIDEVS[$((port-1))]}"
609             link: "link$((port-1))"
610             model: ${TG_MODELS[$((port-1))]}
611             driver: "${TG_DRIVERS[$((port-1))]}"
612             vlan: ${TG_VLANS[$((port-1))]}
613 EOF
614     )
615         CSIT_TG_INTERFACES+=$'\n'
616     done
617     for port in $(seq "${#DUT1_NETMACS[*]}"); do
618         CSIT_DUT1_INTERFACES+=$(cat << EOF
619         port$((port-1)):
620             mac_address: "${DUT1_NETMACS[$((port-1))]}"
621             pci_address: "${DUT1_PCIDEVS[$((port-1))]}"
622             link: "link$((port-1))"
623             model: ${DUT1_MODELS[$((port-1))]}
624             driver: "${DUT1_DRIVERS[$((port-1))]}"
625             vlan: ${DUT1_VLANS[$((port-1))]}
626 EOF
627     )
628         CSIT_DUT1_INTERFACES+=$'\n'
629     done
630 }
631
632
633 function print_env_variables () {
634
635     # Get environment variables prefixed by CSIT_.
636
637     set -exuo pipefail
638
639     env | grep CSIT_ || true
640 }
641
642
643 function read_env_variables () {
644
645     # Read environment variables from parameters.
646     #
647     # Arguments:
648     # - ${@} - Variables passed as an argument.
649     # Variables read, set or exported: Multiple,
650     # see the code for the current list.
651
652     set -exuo pipefail
653
654     for param in "$@"; do
655         export "${param}"
656     done
657     declare -gA DCR_UUIDS
658     DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
659     DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
660
661     IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
662     IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
663     IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
664     IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
665     IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
666     IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
667     IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
668     IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
669     IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
670     IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
671 }
672
673
674 function set_env_variables () {
675
676     # Set environment variables.
677     #
678     # Variables read:
679     # - DCR_UUIDS - Docker Container UUIDs.
680     # - DCR_PORTS - Docker Container's SSH ports.
681     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
682     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
683     # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
684     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
685     # - DUT1_VLANS - List of interface vlans to TG container.
686     # - DUT1_MODEL - List of interface models to TG container.
687     # - TG_NETDEVS - List of network devices allocated to TG container.
688     # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
689     # - TG_NETMACS - List of MAC addresses allocated to TG container.
690     # - TG_DRIVERS - List of interface drivers to TG container.
691     # - TG_VLANS - List of interface vlans to TG container.
692     # - TG_MODEL - List of interface models to TG container.
693
694     set -exuo pipefail
695
696     set -a
697     CSIT_TG_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
698         die "Reading hostname IP address failed!"
699     }
700     CSIT_TG_PORT="${DCR_PORTS[tg]#*:}"
701     CSIT_TG_UUID="${DCR_UUIDS[tg]}"
702     CSIT_TG_ARCH="$(uname -i)" || {
703         die "Reading machine architecture failed!"
704     }
705     CSIT_DUT1_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
706         die "Reading hostname IP address failed!"
707     }
708     CSIT_DUT1_PORT="${DCR_PORTS[dut1]#*:}"
709     CSIT_DUT1_UUID="${DCR_UUIDS[dut1]}"
710     CSIT_DUT1_ARCH="$(uname -i)" || {
711         die "Reading machine architecture failed!"
712     }
713     OIFS="$IFS" IFS=@
714     set -a
715     CSIT_TG_INTERFACES_PORT_MAC="${TG_NETMACS[*]}"
716     CSIT_TG_INTERFACES_PORT_PCI="${TG_PCIDEVS[*]}"
717     CSIT_TG_INTERFACES_PORT_DRV="${TG_DRIVERS[*]}"
718     CSIT_TG_INTERFACES_PORT_VLAN="${TG_VLANS[*]}"
719     CSIT_TG_INTERFACES_PORT_MODEL="${TG_MODELS[*]}"
720     CSIT_DUT1_INTERFACES_PORT_MAC="${DUT1_NETMACS[*]}"
721     CSIT_DUT1_INTERFACES_PORT_PCI="${DUT1_PCIDEVS[*]}"
722     CSIT_DUT1_INTERFACES_PORT_DRV="${DUT1_DRIVERS[*]}"
723     CSIT_DUT1_INTERFACES_PORT_VLAN="${DUT1_VLANS[*]}"
724     CSIT_DUT1_INTERFACES_PORT_MODEL="${DUT1_MODELS[*]}"
725     set +a
726     IFS="$OIFS"
727 }
728
729
730 function start_topology_containers () {
731
732     # Starts csit-sut-dcr docker containers for TG/DUT1.
733     #
734     # Variables read:
735     # - CSIT_DIR - Path to existing root of local CSIT git repository.
736     # Variables set:
737     # - DCR_UUIDS - Docker Container UUIDs.
738     # - DCR_PORTS - Docker Container SSH TCP ports.
739     # - DCR_CPIDS - Docker Container PIDs (namespaces).
740
741     set -exuo pipefail
742
743     if ! installed docker; then
744         die "Docker not present. Please install before continue!"
745     fi
746
747     # If the IMAGE is not already loaded then docker run will pull the IMAGE,
748     # and all image dependencies, before it starts the container.
749     dcr_image="${1}"
750     # Run the container in the background and print the new container ID.
751     dcr_stc_params="--detach=true "
752     # Give extended privileges to this container. A "privileged" container is
753     # given access to all devices and able to run nested containers.
754     dcr_stc_params+="--privileged "
755     # Publish all exposed ports to random ports on the host interfaces.
756     dcr_stc_params+="--publish-all "
757     # Automatically remove the container when it exits.
758     dcr_stc_params+="--rm "
759     # Size of /dev/shm.
760     dcr_stc_params+="--shm-size 2G "
761     # Override access to PCI bus by attaching a filesystem mount to the
762     # container.
763     dcr_stc_params+="--mount type=tmpfs,destination=/sys/bus/pci/devices "
764     # Mount vfio devices to be able to use VFs inside the container.
765     vfio_bound="false"
766     for PCI_ADDR in ${DUT1_PCIDEVS[@]}; do
767         get_krn_driver
768         if [[ ${KRN_DRIVER} == "vfio-pci" ]]; then
769             get_vfio_group
770             dcr_stc_params+="--device /dev/vfio/${VFIO_GROUP} "
771             vfio_bound="true"
772         fi
773     done
774     if ! ${vfio_bound}; then
775         dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
776     fi
777     # Disable manipulation with hugepages by VPP.
778     dcr_stc_params+="--volume /dev/null:/etc/sysctl.d/80-vpp.conf "
779     # Mount docker.sock to be able to use docker deamon of the host.
780     dcr_stc_params+="--volume /var/run/docker.sock:/var/run/docker.sock "
781     # Mount /opt/boot/ where VM kernel and initrd are located.
782     dcr_stc_params+="--volume /opt/boot/:/opt/boot/ "
783     # Mount host hugepages for VMs.
784     dcr_stc_params+="--volume /dev/hugepages/:/dev/hugepages/ "
785     # Disable IPv6.
786     dcr_stc_params+="--sysctl net.ipv6.conf.all.disable_ipv6=1 "
787     dcr_stc_params+="--sysctl net.ipv6.conf.default.disable_ipv6=1 "
788
789     # Docker Container UUIDs.
790     declare -gA DCR_UUIDS
791     # Docker Container SSH TCP ports.
792     declare -gA DCR_PORTS
793     # Docker Container PIDs (namespaces).
794     declare -gA DCR_CPIDS
795
796     # Run TG and DUT1. As initial version we do support only 2-node.
797     params=(${dcr_stc_params} --name csit-tg-$(uuidgen) ${dcr_image})
798     DCR_UUIDS+=([tg]=$(docker run "${params[@]}")) || {
799         die "Failed to start TG docker container!"
800     }
801     params=(${dcr_stc_params} --name csit-dut1-$(uuidgen) ${dcr_image})
802     DCR_UUIDS+=([dut1]=$(docker run "${params[@]}")) || {
803         die "Failed to start DUT1 docker container!"
804     }
805
806     trap 'clean_environment_on_exit' EXIT || {
807         die "Trap attempt failed, please cleanup manually. Aborting!"
808     }
809
810     # Get Containers TCP ports.
811     params=(${DCR_UUIDS[tg]})
812     DCR_PORTS+=([tg]=$(docker port "${params[@]}")) || {
813         die "Failed to get port of TG docker container!"
814     }
815     params=(${DCR_UUIDS[dut1]})
816     DCR_PORTS+=([dut1]=$(docker port "${params[@]}")) || {
817         die "Failed to get port of DUT1 docker container!"
818     }
819
820     # Get Containers PIDs.
821     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[tg]})
822     DCR_CPIDS+=([tg]=$(docker inspect "${params[@]}")) || {
823         die "Failed to get PID of TG docker container!"
824     }
825     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[dut1]})
826     DCR_CPIDS+=([dut1]=$(docker inspect "${params[@]}")) || {
827         die "Failed to get PID of DUT1 docker container!"
828     }
829 }
830
831 function warn () {
832     # Print the message to standard error.
833     #
834     # Duplicate of common.sh function, as this file is also used standalone.
835     #
836     # Arguments:
837     # - ${@} - The text of the message.
838
839     set -exuo pipefail
840
841     echo "$@" >&2
842 }